gtkmm: Gdk::Window Class Reference

gtkmm 3.4.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gdk::Window Class Reference

A Gdk::Window is a rectangular region on the screen. More...

Inheritance diagram for Gdk::Window:
[legend]

List of all members.

## Public Member Functions
virtual | ~Window ()
GdkWindow* | gobj ()
| Provides access to the underlying C GObject.
const GdkWindow* | gobj () const
| Provides access to the underlying C GObject.
GdkWindow* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
WindowType | get_window_type () const
| Gets the type of the window.
Glib::RefPtr< Visual > | get_visual ()
| Gets the Gdk::Visual describing the pixel format of window.
Glib::RefPtr< const Visual > | get_visual () const
| Gets the Gdk::Visual describing the pixel format of window.
Glib::RefPtr< Screen > | get_screen ()
| Gets the Gdk::Screen associated with a Gdk::Window.
Glib::RefPtr< const Screen > | get_screen () const
| Gets the Gdk::Screen associated with a Gdk::Window.
Glib::RefPtr< Display > | get_display ()
| Gets the Gdk::Display associated with a Gdk::Window.
Glib::RefPtr< const Display > | get_display () const
| Gets the Gdk::Display associated with a Gdk::Window.
void | show ()
| Like show_unraised(), but also raises the window to the top of the window stack (moves the window to the front of the Z-order).
void | hide ()
| For toplevel windows, withdraws them, so they will no longer be known to the window manager; for all windows, unmaps them, so they won't be displayed.
void | withdraw ()
| Withdraws a window (unmaps it and asks the window manager to forget about it).
void | show_unraised ()
| Shows a Gdk::Window onscreen, but does not modify its stacking order.
void | move (int x, int y)
| Repositions a window relative to its parent window.
void | resize (int width, int height)
| Resizes window; for toplevel windows, asks the window manager to resize the window.
void | move_resize (int x, int y, int width, int height)
| Equivalent to calling move() and resize(), except that both operations are performed at once, avoiding strange visual effects.
void | reparent (const Glib::RefPtr< Window >& new_parent, int x, int y)
| Reparents window into the given new_parent.
void | raise ()
| Raises window to the top of the Z-order (stacking order), so that other windows with the same parent window appear below window.
void | lower ()
| Lowers window to the bottom of the Z-order (stacking order), so that other windows with the same parent window appear above window.
void | restack (const Glib::RefPtr< Window >& sibling, bool above)
| Changes the position of window in the Z-order (stacking order), so that it is above sibling (if above is `true`) or below sibling (if above is `false`).
void | restack (bool above)
| Changes the position of this window in the Z-order (stacking order).
void | focus (guint32 timestamp)
| Sets keyboard focus to window.
void | set_user_data (gpointer user_data)
| For most purposes this function is deprecated in favor of Glib::object_set_data().
void | set_override_redirect (bool override_redirect=true)
| An override redirect window is not under the control of the window manager.
void | add_filter (GdkFilterFunc function, gpointer data)
| Adds an event filter to window, allowing you to intercept events before they reach GDK.
void | remove_filter (GdkFilterFunc function, gpointer data)
| Remove a filter previously added with add_filter().
void | scroll (int dx, int dy)
| Scroll the contents of window, both pixels and children, by the given amount.
void | move_region (const ::Cairo::RefPtr< ::Cairo::Region >& region, int dx, int dy)
| Move the part of window indicated by region by dy pixels in the Y direction and dx pixels in the X direction.
bool | ensure_native ()
| Tries to ensure that there is a window-system native window for this GdkWindow.
void | shape_combine_region (const ::Cairo::RefPtr< ::Cairo::Region >& shape_region, int offset_x=0, int offset_y=0)
| Makes pixels in window outside shape_region be transparent, so that the window may be nonrectangular.
void | set_child_shapes ()
| Sets the shape mask of window to the union of shape masks for all children of window, ignoring the shape mask of window itself.
bool | get_composited () const
| Determines whether window is composited.
void | set_composited (bool composited=TRUE)
| Sets a Gdk::Window as composited, or unsets it.
void | merge_child_shapes ()
| Merges the shape masks for any child windows into the shape mask for window.
void | input_shape_combine_region (const ::Cairo::RefPtr< ::Cairo::Region >& shape_region, int offset_x, int offset_y)
| Like shape_combine_region(), but the shape applies only to event handling.
void | set_child_input_shapes ()
| Sets the input shape mask of window to the union of input shape masks for all children of window, ignoring the input shape mask of window itself.
void | merge_child_input_shapes ()
| Merges the input shape masks for any child windows into the input shape mask for window.
bool | is_visible () const
| Checks whether the window has been mapped (with show() or show_unraised()).
bool | is_viewable () const
| Check if the window and all ancestors of the window are mapped.
bool | is_input_only () const
| Determines whether or not the window is an input only window.
bool | is_shaped () const
| Determines whether or not the window is shaped.
WindowState | get_state () const
| Gets the bitwise OR of the currently active window state flags, from the Gdk::WindowState enumeration.
bool | set_static_gravities (bool use_static=true)
| Set the bit gravity of the given window to static, and flag it so all children get static subwindow gravity.
bool | has_native () const
| Checks whether the window has a native window or not.
void | set_type_hint (WindowTypeHint hint)
| The application can use this call to provide a hint to the window manager about the functionality of a window.
WindowTypeHint | get_type_hint ()
| This function returns the type hint set for a window.
bool | get_modal_hint () const
| Determines whether or not the window manager is hinted that window has modal behaviour.
void | set_modal_hint (bool modal=true)
| The application can use this hint to tell the window manager that a certain window has modal behaviour.
void | set_geometry_hints (const Geometry& geometry, WindowHints geom_mask)
| Sets the geometry hints for window.
void | begin_paint_rect (const Rectangle& rectangle)
| A convenience wrapper around begin_paint_region() which creates a rectangular region for you.
void | begin_paint_region (const ::Cairo::RefPtr< ::Cairo::Region >& region)
| Indicates that you are beginning the process of redrawing region.
void | end_paint ()
| Indicates that the backing store created by the most recent call to begin_paint_region() should be copied onscreen and deleted, leaving the next-most-recent backing store or no backing store at all as the active paint region.
void | flush ()
| Flush all outstanding cached operations on a window, leaving the window in a state which reflects all that has been drawn before.
void | set_title (const Glib::ustring& title)
| Sets the title of a toplevel window, to be displayed in the titlebar.
void | set_role (const Glib::ustring& role)
| When using GTK+, typically you should use gtk_window_set_role() instead of this low-level function.
void | set_startup_id (const Glib::ustring& startup_id)
| When using GTK+, typically you should use gtk_window_set_startup_id() instead of this low-level function.
void | set_transient_for (const Glib::RefPtr< Window >& parent)
| Indicates to the window manager that window is a transient dialog associated with the application window parent.
void | set_background (const Color& color)
| Sets the background color of window.
void | set_background (const RGBA& color)
| Sets the background color of window.
void | set_background (const ::Cairo::RefPtr< ::Cairo::Pattern >& pattern)
| Sets the background of window.
::Cairo::RefPtr< ::Cairo::Pattern > | get_background_pattern ()
| Gets the pattern used to clear the background on window.
::Cairo::RefPtr< const ::Cairo::Pattern > | get_background_pattern () const
| Gets the pattern used to clear the background on window.
void | set_cursor (const Glib::RefPtr< Cursor >& cursor)
| Sets the mouse pointer for a Gdk::Window.
void | set_cursor ()
| Use the parent window's cursor.
void | set_device_cursor (const Glib::RefPtr< Device >& device, const Glib::RefPtr< Cursor >& cursor)
| Sets a specific Gdk::Cursor for a given device when it gets inside window.
void | set_device_cursor (const Glib::RefPtr< Device >& device)
| Use the parent window's cursor.
Glib::RefPtr< Cursor > | get_device_cursor (const Glib::RefPtr< Device >& device)
| Retrieves a Gdk::Cursor pointer for the device currently set on the specified Gdk::Window, or `0`.
Glib::RefPtr< const Cursor > | get_device_cursor (const Glib::RefPtr< const Device >& device) const
| Retrieves a Gdk::Cursor pointer for the device currently set on the specified Gdk::Window, or `0`.
Glib::RefPtr< Cursor > | get_cursor ()
| Retrieves a Gdk::Cursor pointer for the cursor currently set on the specified Gdk::Window, or `0`.
Glib::RefPtr< const Cursor > | get_cursor () const
| Retrieves a Gdk::Cursor pointer for the cursor currently set on the specified Gdk::Window, or `0`.
void | get_user_data (gpointer* data)
| Retrieves the user data for window, which is normally the widget that window belongs to.
void | get_geometry (int& x, int& y, int& width, int& height) const
| Any of the return location arguments to this function may be `0`, if you aren't interested in getting the value of that field.
int | get_width () const
| Returns the width of the given window.
int | get_height () const
| Returns the height of the given window.
void | get_position (int& x, int& y) const
| Obtains the position of the window as reported in the most-recently-processed Gdk::EventConfigure.
int | get_origin (int& x, int& y) const
| Obtains the position of a window in root window coordinates.
void | get_root_coords (int x, int y, int& root_x, int& root_y)
| Obtains the position of a window position in root window coordinates.
void | coords_to_parent (double x, double y, double& parent_x, double& parent_y)
| Transforms window coordinates from a child window to its parent window, where the parent window is the normal parent as returned by get_parent() for normal windows, and the window's embedder as returned by gdk_offscreen_window_get_embedder() for offscreen windows.
void | coords_from_parent (double parent_x, double parent_y, double& x, double& y)
| Transforms window coordinates from a parent window to a child window, where the parent window is the normal parent as returned by get_parent() for normal windows, and the window's embedder as returned by gdk_offscreen_window_get_embedder() for offscreen windows.
void | get_root_origin (int& x, int& y) const
| Obtains the top-left corner of the window manager frame in root window coordinates.
void | get_frame_extents (Rectangle& rect)
| Obtains the bounding box of the window, including window manager titlebar/borders if any.
Glib::RefPtr< Window > | get_pointer (int& x, int& y, ModifierType& mask)
| Obtains the current pointer position and modifier state.
Glib::RefPtr< Window > | get_parent ()
| Obtains the parent of window, as known to GDK.
Glib::RefPtr< const Window > | get_parent () const
| Obtains the parent of window, as known to GDK.
Glib::RefPtr< Window > | get_toplevel ()
| Gets the toplevel window that's an ancestor of window.
Glib::RefPtr< const Window > | get_toplevel () const
| Gets the toplevel window that's an ancestor of window.
Glib::RefPtr< Window > | get_device_position (const Glib::RefPtr< const Device >& device, int& x, int& y, ModifierType& mask) const
| Obtains the current device position and modifier state.
Glib::RefPtr< Window > | get_effective_parent ()
| Obtains the parent of window, as known to GDK.
Glib::RefPtr< const Window > | get_effective_parent () const
| Obtains the parent of window, as known to GDK.
Glib::RefPtr< Window > | get_effective_toplevel ()
| Gets the toplevel window that's an ancestor of window.
Glib::RefPtr< const Window > | get_effective_toplevel () const
| Gets the toplevel window that's an ancestor of window.
std::vector< Glib::RefPtr < Window > > | get_children ()
| Gets the list of children of window known to GDK.
std::vector< Glib::RefPtr < const Window > > | get_children () const
| Gets the list of children of window known to GDK.
EventMask | get_events () const
| Gets the event mask for window for all master input devices.
void | set_events (EventMask event_mask)
| The event mask for a window determines which events will be reported for that window from all master input devices.
EventMask | get_device_events (const Glib::RefPtr< const Device >& device) const
| Returns the event mask for window corresponding to an specific device.
void | set_device_events (const Glib::RefPtr< Device >& device, EventMask event_mask)
| Sets the event mask for a given device (Normally a floating device, not attached to any visible pointer) to window.
EventMask | get_source_events (InputSource source) const
| Returns the event mask for window corresponding to the device class specified by source.
void | set_source_events (InputSource source, EventMask event_mask)
| Sets the event mask for any floating device (i.e. not attached to any visible pointer) that has the source defined as source.
void | set_icon_list (const std::vector< Glib::RefPtr< Gdk::Pixbuf > >& pixbufs)
| Sets a list of icons for the window.
void | unset_icon ()
void | set_icon_name (const Glib::ustring& name)
| Windows may have a name used while minimized, distinct from the name they display in their titlebar.
void | set_group (const Glib::RefPtr< Window >& leader)
| Sets the group leader window for window.
Glib::RefPtr< Window > | get_group ()
| Returns the group leader window for window.
Glib::RefPtr< const Window > | get_group () const
| Returns the group leader window for window.
void | set_decorations (WMDecoration decorations)
| "Decorations" are the features the window manager adds to a toplevel Gdk::Window.
bool | get_decorations (WMDecoration& decorations) const
| Returns the decorations set on the GdkWindow with set_decorations().
void | set_functions (WMFunction functions)
| Sets hints about the window management functions to make available via buttons on the window frame.
::Cairo::RefPtr< ::Cairo::Surface > | create_similar_surface (::Cairo::Content content, int width, int height)
| Create a new surface that is as compatible as possible with the given window.
void | beep ()
| Emits a short beep associated to window in the appropriate display, if supported.
void | iconify ()
| Asks to iconify (minimize) window.
void | deiconify ()
| Attempt to deiconify (unminimize) window.
void | stick ()
| "Pins" a window such that it's on all workspaces and does not scroll with viewports, for window managers that have scrollable viewports.
void | unstick ()
| Reverse operation for stick(); see stick(), and gtk_window_unstick().
void | maximize ()
| Maximizes the window.
void | unmaximize ()
| Unmaximizes the window.
void | register_dnd ()
| Registers a window as a potential drop destination.
DragProtocol | get_drag_protocol (Glib::RefPtr< Window >& target) const
| Finds out the DND protocol supported by a window.
DragProtocol | get_drag_protocol () const
void | begin_resize_drag (WindowEdge edge, int button, int root_x, int root_y, guint32 timestamp)
| Begins a window resize operation (for a toplevel window).
void | resize_drag (WindowEdge edge, const Glib::RefPtr< Device >& device, int button, int root_x, int root_y, guint32 timestamp)
| Begins a window resize operation (for a toplevel window).
void | begin_move_drag (int button, int root_x, int root_y, guint32 timestamp)
| Begins a window move operation (for a toplevel window).
void | begin_move_drag (const Glib::RefPtr< Device >& device, int button, int root_x, int root_y, guint32 timestamp)
| Begins a window move operation (for a toplevel window).
Glib::RefPtr< DragContext > | drag_begin (const std::vector< Glib::ustring >& targets)
| Starts a drag and creates a new drag context for it.
void | invalidate_rect (const Rectangle& rect, bool invalidate_children)
| A convenience wrapper around invalidate_region() which invalidates a rectangular region.
void | invalidate (bool invalidate_children)
| A convenience wrapper around invalidate_region() which invalidates the whole region.
void | invalidate_region (const ::Cairo::RefPtr< ::Cairo::Region >& region, bool invalidate_children=true)
| Adds region to the update area for window.
::Cairo::RefPtr< ::Cairo::Region > | get_update_area ()
| Transfers ownership of the update area from window to the caller of the function.
void | freeze_updates ()
| Temporarily freezes a window such that it won't receive expose events.
void | thaw_updates ()
| Thaws a window frozen with Gdk::Window::freeze_updates().
void | process_updates (bool update_children)
| Sends one or more expose events to window.
void | enable_synchronized_configure ()
| Indicates that the application will cooperate with the window system in synchronizing the window repaint with the window manager during resizing operations.
void | configure_finished ()
| Signal to the window system that the application has finished handling Configure events it has received.
void | set_skip_taskbar_hint (bool skips_taskbar=true)
| Toggles whether a window should appear in a task list or window list.
void | set_skip_pager_hint (bool skips_pager=true)
| Toggles whether a window should appear in a pager (workspace switcher, or other desktop utility program that displays a small thumbnail representation of the windows on the desktop).
void | set_urgency_hint (bool urgent=true)
| Toggles whether a window needs the user's urgent attention.
void | fullscreen ()
| Moves the window into fullscreen mode.
void | unfullscreen ()
| Moves the window out of fullscreen mode.
void | set_keep_above (bool setting=true)
| Set if window must be kept above other windows.
void | set_keep_below (bool setting=true)
| Set if window must be kept below other windows.
void | set_opacity (double opacity)
| Request the windowing system to make window partially transparent, with opacity 0 being fully transparent and 1 fully opaque.
bool | get_accept_focus () const
| Determines whether or not the desktop environment shuld be hinted that the window does not want to receive input focus.
void | set_accept_focus (bool accept_focus=true)
| Setting accept_focus to `false` hints the desktop environment that the window doesn't want to receive input focus.
bool | get_focus_on_map () const
| Determines whether or not the desktop environment should be hinted that the window does not want to receive input focus when it is mapped.
void | set_focus_on_map (bool focus_on_map)
| Setting focus_on_map to `false` hints the desktop environment that the window doesn't want to receive input focus when it is mapped.
::Cairo::RefPtr< ::Cairo::Surface > | get_offscreen_surface ()
| Gets the offscreen surface that an offscreen window renders into.
::Cairo::RefPtr< const ::Cairo::Surface > | get_offscreen_surface () const
| Gets the offscreen surface that an offscreen window renders into.
Glib::RefPtr< Window > | get_offscreen_embedder ()
| Gets the window that window is embedded in.
Glib::RefPtr< const Window > | get_offscreen_embedder () const
| Gets the window that window is embedded in.
void | set_offscreen_embedder (const Glib::RefPtr< Window >& embedder)
| Sets window to be embedded in embedder.
void | geometry_changed ()
| This function informs GDK that the geometry of an embedded offscreen window has changed.
void | set_support_multidevice (bool support_multidevice=true)
| This function will enable multidevice features in window.
bool | get_support_multidevice ()
| Returns `true` if the window is aware of the existence of multiple devices.
::Cairo::RefPtr< ::Cairo::Region > | get_clip_region () const
| Computes the region of a window that potentially can be written to by drawing primitives.
::Cairo::RefPtr< ::Cairo::Region > | get_visible_region () const
| Computes the region of the window that is potentially visible.
::Cairo::RefPtr< ::Cairo::Context > | create_cairo_context ()
| Creates a Cairo context for drawing to drawable.
Glib::PropertyProxy < Glib::RefPtr< Cursor > > | property_cursor ()
| Cursor.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Cursor > > | property_cursor () const
| Cursor.
## Static Public Member Functions
static Glib::RefPtr< Window > | create (const Glib::RefPtr< Window >& parent, GdkWindowAttr* attributes, int attributes_mask)
static void | process_all_updates ()
| Calls process_updates() for all windows (see Gdk::Window) in the application.
static void | set_debug_updates (bool setting=true)
| With update debugging enabled, calls to invalidate_region() clear the invalidated region of the screen to a noticeable color, and GDK pauses for a short time before sending exposes to windows during process_updates().
static void | constrain_size (const Geometry& geometry, guint flags, int width, int height, int& new_width, int& new_height)
| Constrains a desired width and height according to a set of geometry hints (such as minimum and maximum size).
static Glib::RefPtr< Window > | get_default_root_window ()
| Obtains the root window (parent all other windows are inside) for the default display and screen.
## Protected Member Functions
| Window (const Glib::RefPtr< Window >& parent, GdkWindowAttr* attributes, int attributes_mask)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::Window > | wrap (GdkWindow* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Gdk::Window is a rectangular region on the screen.

It's a low-level object, used to implement high-level objects such as Gtk::Widget and Gtk::Window on the GTK+ level. A Gtk::Window is a toplevel window, the thing a user might think of as a "window" with a titlebar and so on; a Gtk::Window may contain many Gdk::Windows. For example, each Gtk::Button has a Gdk::Window associated with it.

## Constructor & Destructor Documentation

virtual Gdk::Window::~Window | ( |  | ) | `[virtual]`

Gdk::Window::Window | ( | const Glib::RefPtr< Window >& | parent,
|  | GdkWindowAttr * | attributes,
|  | int | attributes_mask
| ) |  | `[protected]`

## Member Function Documentation

void Gdk::Window::add_filter | ( | GdkFilterFunc | function,
|  | gpointer | data
| ) |  |

Adds an event filter to window, allowing you to intercept events before they reach GDK.

This is a low-level operation and makes it easy to break GDK and/or GTK+, so you have to know what you're doing. Pass `0` for window to get all events for all windows, instead of events for a specific window.

If you are interested in X GenericEvents, bear in mind that XGetEventData() has been already called on the event, and XFreeEventData() must not be called within function.

Parameters:

  function | Filter callback.
  data | Data to pass to filter callback.

void Gdk::Window::beep | ( |  | ) |

Emits a short beep associated to window in the appropriate display, if supported.

Otherwise, emits a short beep on the display just as Gdk::Display::beep().

Since gtkmm 2.12:

void Gdk::Window::begin_move_drag | ( | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp
| ) |  |

Begins a window move operation (for a toplevel window).

This function assumes that the drag is controlled by the client pointer device, use begin_move_drag_for_device() to begin a drag with a different device.

Parameters:

  button | The button being used to drag.
  root_x | Root window X coordinate of mouse click that began the drag.
  root_y | Root window Y coordinate of mouse click that began the drag.
  timestamp | Timestamp of mouse click that began the drag.

void Gdk::Window::begin_move_drag | ( | const Glib::RefPtr< Device >& | device,
|  | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp
| ) |  |

Begins a window move operation (for a toplevel window).

You might use this function to implement a "window move grip," for example. The function works best with window managers that support the Extended Window Manager Hints, but has a fallback implementation for other window managers.

Since gtkmm 3.4:

Parameters:

  device | The device used for the operation.
  button | The button being used to drag.
  root_x | Root window X coordinate of mouse click that began the drag.
  root_y | Root window Y coordinate of mouse click that began the drag.
  timestamp | Timestamp of mouse click that began the drag.

void Gdk::Window::begin_paint_rect | ( | const Rectangle& | rectangle | ) |

A convenience wrapper around begin_paint_region() which creates a rectangular region for you.

See begin_paint_region() for details.

Parameters:

  rectangle | Rectangle you intend to draw to.

void Gdk::Window::begin_paint_region | ( | const ::Cairo::RefPtr< ::Cairo::Region > & | region | ) |

Indicates that you are beginning the process of redrawing region.

A backing store (offscreen buffer) large enough to contain region will be created. The backing store will be initialized with the background color or background surface for window. Then, all drawing operations performed on window will be diverted to the backing store. When you call end_paint(), the backing store will be copied to window, making it visible onscreen. Only the part of window contained in region will be modified; that is, drawing operations are clipped to region.

The net result of all this is to remove flicker, because the user sees the finished product appear all at once when you call end_paint(). If you draw to window directly without calling begin_paint_region(), the user may see flicker as individual drawing operations are performed in sequence. The clipping and background-initializing features of begin_paint_region() are conveniences for the programmer, so you can avoid doing that work yourself.

When using GTK+, the widget system automatically places calls to begin_paint_region() and end_paint() around emissions of the expose_event signal. That is, if you're writing an expose event handler, you can assume that the exposed area in Gdk::EventExpose has already been cleared to the window background, is already set as the clip region, and already has a backing store. Therefore in most cases, application code need not call begin_paint_region(). (You can disable the automatic calls around expose events on a widget-by-widget basis by calling gtk_widget_set_double_buffered().)

If you call this function multiple times before calling the matching end_paint(), the backing stores are pushed onto a stack. end_paint() copies the topmost backing store onscreen, subtracts the topmost region from all other regions in the stack, and pops the stack. All drawing operations affect only the topmost backing store in the stack. One matching call to end_paint() is required for each call to begin_paint_region().

Parameters:

  region | Region you intend to draw to.

void Gdk::Window::begin_resize_drag | ( | WindowEdge | edge,
|  | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp
| ) |  |

Begins a window resize operation (for a toplevel window).

This function assumes that the drag is controlled by the client pointer device, use begin_resize_drag_for_device() to begin a drag with a different device.

Parameters:

  edge | The edge or corner from which the drag is started.
  button | The button being used to drag.
  root_x | Root window X coordinate of mouse click that began the drag.
  root_y | Root window Y coordinate of mouse click that began the drag.
  timestamp | Timestamp of mouse click that began the drag (use Gdk::Event::get_time()).

void Gdk::Window::configure_finished | ( |  | ) |

Signal to the window system that the application has finished handling Configure events it has received.

Window Managers can use this to better synchronize the frame repaint with the application. GTK+ applications will automatically call this function when appropriate.

This function can only be called if enable_synchronized_configure() was called previously.

Since gtkmm 2.6:

static void Gdk::Window::constrain_size | ( | const Geometry& | geometry,
|  | guint | flags,
|  | int | width,
|  | int | height,
|  | int & | new_width,
|  | int & | new_height
| ) |  | `[static]`

Constrains a desired width and height according to a set of geometry hints (such as minimum and maximum size).

Parameters:

  geometry | A Gdk::Geometry structure.
  flags | A mask indicating what portions of geometry are set.
  width | Desired width of window.
  height | Desired height of the window.
  new_width | Location to store resulting width.
  new_height | Location to store resulting height.

void Gdk::Window::coords_from_parent | ( | double | parent_x,
|  | double | parent_y,
|  | double & | x,
|  | double & | y
| ) |  |

Transforms window coordinates from a parent window to a child window, where the parent window is the normal parent as returned by get_parent() for normal windows, and the window's embedder as returned by gdk_offscreen_window_get_embedder() for offscreen windows.

For normal windows, calling this function is equivalent to subtracting the return values of get_position() from the parent coordinates. For offscreen windows however (which can be arbitrarily transformed), this function calls the GdkWindow::from-embedder: signal to translate the coordinates.

You should always use this function when writing generic code that walks down a window hierarchy.

See also: coords_to_parent()

Since gtkmm 2.22:

Parameters:

  parent_x | X coordinate in parent's coordinate system.
  parent_y | Y coordinate in parent's coordinate system.
  x | Return location for X coordinate in child's coordinate system.
  y | Return location for Y coordinate in child's coordinate system.

void Gdk::Window::coords_to_parent | ( | double | x,
|  | double | y,
|  | double & | parent_x,
|  | double & | parent_y
| ) |  |

Transforms window coordinates from a child window to its parent window, where the parent window is the normal parent as returned by get_parent() for normal windows, and the window's embedder as returned by gdk_offscreen_window_get_embedder() for offscreen windows.

For normal windows, calling this function is equivalent to adding the return values of get_position() to the child coordinates. For offscreen windows however (which can be arbitrarily transformed), this function calls the GdkWindow::to-embedder: signal to translate the coordinates.

You should always use this function when writing generic code that walks up a window hierarchy.

See also: coords_from_parent()

Since gtkmm 2.22:

Parameters:

  x | X coordinate in child's coordinate system.
  y | Y coordinate in child's coordinate system.
  parent_x | Return location for X coordinate in parent's coordinate system, or `0`.
  parent_y | Return location for Y coordinate in parent's coordinate system, or `0`.

static Glib::RefPtr<Window> Gdk::Window::create | ( | const Glib::RefPtr< Window >& | parent,
|  | GdkWindowAttr * | attributes,
|  | int | attributes_mask
| ) |  | `[static]`

::Cairo::RefPtr< ::Cairo::Context> Gdk::Window::create_cairo_context | ( |  | ) |

Creates a Cairo context for drawing to drawable.

Returns:
  A newly created Cairo context.

Since gtkmm 2.10:

::Cairo::RefPtr< ::Cairo::Surface> Gdk::Window::create_similar_surface | ( | ::Cairo::Content | content,
|  | int | width,
|  | int | height
| ) |  |

Create a new surface that is as compatible as possible with the given window.

For example the new surface will have the same fallback resolution and font options as window. Generally, the new surface will also use the same backend as window, unless that is not possible for some reason. The type of the returned surface may be examined with cairo_surface_get_type().

Initially the surface contents are all 0 (transparent if contents have transparency, black otherwise.)

Since gtkmm 2.22:

Parameters:

  content | The content for the new surface.
  width | Width of the new surface.
  height | Height of the new surface.

Returns:
  A pointer to the newly allocated surface. The caller owns the surface and should call cairo_surface_destroy() when done with it.

This function always returns a valid pointer, but it will return a pointer to a "nil" surface if other is already in an error state or any other error occurs.

void Gdk::Window::deiconify | ( |  | ) |

Attempt to deiconify (unminimize) window.

On X11 the window manager may choose to ignore the request to deiconify. When using GTK+, use gtk_window_deiconify() instead of the Gdk::Window variant. Or better yet, you probably want to use gtk_window_present(), which raises the window, focuses it, unminimizes it, and puts it on the current desktop.

Glib::RefPtr<DragContext> Gdk::Window::drag_begin | ( | const std::vector< Glib::ustring > & | targets | ) |

Starts a drag and creates a new drag context for it.

This method is called by the drag source.

Parameters:

  window | The source window for this drag.
  targets | A list of the offered targets names.

Returns:
  A newly created Gdk::DragContext.

Since gtkmm 2.24:

void Gdk::Window::enable_synchronized_configure | ( |  | ) |

Indicates that the application will cooperate with the window system in synchronizing the window repaint with the window manager during resizing operations.

After an application calls this function, it must call configure_finished() every time it has finished all processing associated with a set of Configure events. Toplevel GTK+ windows automatically use this protocol.

On X, calling this function makes window participate in the _NET_WM_SYNC_REQUEST window manager protocol.

Since gtkmm 2.6:

void Gdk::Window::end_paint | ( |  | ) |

Indicates that the backing store created by the most recent call to begin_paint_region() should be copied onscreen and deleted, leaving the next-most-recent backing store or no backing store at all as the active paint region.

See begin_paint_region() for full details. It is an error to call this function without a matching begin_paint_region() first.

bool Gdk::Window::ensure_native | ( |  | ) |

Tries to ensure that there is a window-system native window for this GdkWindow.

This may fail in some situations, returning `false`.

Offscreen window and children of them can never have native windows.

Some backends may not support native child windows.

Since gtkmm 2.18:

Returns:
  `true` if the window has a native window, `false` otherwise.

void Gdk::Window::flush | ( |  | ) |

Flush all outstanding cached operations on a window, leaving the window in a state which reflects all that has been drawn before.

Gdk uses multiple kinds of caching to get better performance and nicer drawing. For instance, during exposes all paints to a window using double buffered rendering are keep on a surface until the last window has been exposed. It also delays window moves/scrolls until as long as possible until next update to avoid tearing when moving windows.

Normally this should be completely invisible to applications, as we automatically flush the windows when required, but this might be needed if you for instance mix direct native drawing with gdk drawing. For Gtk widgets that don't use double buffering this will be called automatically before sending the expose event.

Since gtkmm 2.18:

void Gdk::Window::focus | ( | guint32 | timestamp | ) |

Sets keyboard focus to window.

In most cases, gtk_window_present() should be used on a Gtk::Window, rather than calling this function.

Parameters:

  timestamp | Timestamp of the event triggering the window focus.

void Gdk::Window::freeze_updates | ( |  | ) |

Temporarily freezes a window such that it won't receive expose events.

The window will begin receiving expose events again when Gdk::Window::thaw_updates() is called. If Gdk::Window::freeze_updates() has been called more than once, Gdk::Window::thaw_updates() must be called an equal number of times to begin processing exposes.

void Gdk::Window::fullscreen | ( |  | ) |

Moves the window into fullscreen mode.

This means the window covers the entire screen and is above any panels or task bars.

If the window was already fullscreen, then this function does nothing.

On X11, asks the window manager to put window in a fullscreen state, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "fullscreen"; so you can't rely on the fullscreenification actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

Since gtkmm 2.2:

void Gdk::Window::geometry_changed | ( |  | ) |

This function informs GDK that the geometry of an embedded offscreen window has changed.

This is necessary for GDK to keep track of which offscreen window the pointer is in.

Since gtkmm 2.18:

bool Gdk::Window::get_accept_focus | ( |  | ) | const

Determines whether or not the desktop environment shuld be hinted that the window does not want to receive input focus.

Since gtkmm 2.22:

Returns:
  Whether or not the window should receive input focus.

::Cairo::RefPtr< ::Cairo::Pattern> Gdk::Window::get_background_pattern | ( |  | ) |

Gets the pattern used to clear the background on window.

If window does not have its own background and reuses the parent's, `0` is returned and you'll have to query it yourself.

Since gtkmm 2.22:

Returns:
  The pattern to use for the background or `0` to use the parent's background.

::Cairo::RefPtr<const ::Cairo::Pattern> Gdk::Window::get_background_pattern | ( |  | ) | const

Gets the pattern used to clear the background on window.

If window does not have its own background and reuses the parent's, `0` is returned and you'll have to query it yourself.

Since gtkmm 2.22:

Returns:
  The pattern to use for the background or `0` to use the parent's background.

std::vector< Glib::RefPtr<Window> > Gdk::Window::get_children | ( |  | ) |

Gets the list of children of window known to GDK.

This function only returns children created via GDK, so for example it's useless when used with the root window; it only returns windows an application created itself.

The returned list must be freed, but the elements in the list need not be.

Returns:
  List of child windows inside window.

std::vector< Glib::RefPtr<const Window> > Gdk::Window::get_children | ( |  | ) | const

Gets the list of children of window known to GDK.

This function only returns children created via GDK, so for example it's useless when used with the root window; it only returns windows an application created itself.

The returned list must be freed, but the elements in the list need not be.

Returns:
  List of child windows inside window.

::Cairo::RefPtr< ::Cairo::Region> Gdk::Window::get_clip_region | ( |  | ) | const

Computes the region of a window that potentially can be written to by drawing primitives.

This region may not take into account other factors such as if the window is obscured by other windows, but no area outside of this region will be affected by drawing primitives.

Returns:
  A #cairo_region_t. This must be freed with cairo_region_destroy() when you are done.

bool Gdk::Window::get_composited | ( |  | ) | const

Determines whether window is composited.

See set_composited().

Since gtkmm 2.22:

Returns:
  `true` if the window is composited.

Glib::RefPtr<Cursor> Gdk::Window::get_cursor | ( |  | ) |

Retrieves a Gdk::Cursor pointer for the cursor currently set on the specified Gdk::Window, or `0`.

If the return value is `0` then there is no custom cursor set on the specified window, and it is using the cursor for its parent window.

Since gtkmm 2.18:

Returns:
  A Gdk::Cursor, or `0`. The returned object is owned by the Gdk::Window and should not be unreferenced directly. Use set_cursor() to unset the cursor of the window.

Glib::RefPtr<const Cursor> Gdk::Window::get_cursor | ( |  | ) | const

Retrieves a Gdk::Cursor pointer for the cursor currently set on the specified Gdk::Window, or `0`.

If the return value is `0` then there is no custom cursor set on the specified window, and it is using the cursor for its parent window.

Since gtkmm 2.18:

Returns:
  A Gdk::Cursor, or `0`. The returned object is owned by the Gdk::Window and should not be unreferenced directly. Use set_cursor() to unset the cursor of the window.

bool Gdk::Window::get_decorations | ( | WMDecoration& | decorations | ) | const

Returns the decorations set on the GdkWindow with set_decorations().

Parameters:

  decorations | The window decorations will be written here.

Returns:
  `true` if the window has decorations set, `false` otherwise.

static Glib::RefPtr<Window> Gdk::Window::get_default_root_window | ( |  | ) | `[static]`

Obtains the root window (parent all other windows are inside) for the default display and screen.

Returns:
  The default root window.

Glib::RefPtr<Cursor> Gdk::Window::get_device_cursor | ( | const Glib::RefPtr< Device >& | device | ) |

Retrieves a Gdk::Cursor pointer for the device currently set on the specified Gdk::Window, or `0`.

If the return value is `0` then there is no custom cursor set on the specified window, and it is using the cursor for its parent window.

Since gtkmm 3.0:

Parameters:

  device | A master, pointer Gdk::Device.

Returns:
  A Gdk::Cursor, or `0`. The returned object is owned by the Gdk::Window and should not be unreferenced directly. Use set_cursor() to unset the cursor of the window.

Glib::RefPtr<const Cursor> Gdk::Window::get_device_cursor | ( | const Glib::RefPtr< const Device >& | device | ) | const

Retrieves a Gdk::Cursor pointer for the device currently set on the specified Gdk::Window, or `0`.

If the return value is `0` then there is no custom cursor set on the specified window, and it is using the cursor for its parent window.

Since gtkmm 3.0:

Parameters:

  device | A master, pointer Gdk::Device.

Returns:
  A Gdk::Cursor, or `0`. The returned object is owned by the Gdk::Window and should not be unreferenced directly. Use set_cursor() to unset the cursor of the window.

EventMask Gdk::Window::get_device_events | ( | const Glib::RefPtr< const Device >& | device | ) | const

Returns the event mask for window corresponding to an specific device.

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.

Returns:
  Device event mask for window.

Glib::RefPtr<Window> Gdk::Window::get_device_position | ( | const Glib::RefPtr< const Device >& | device,
|  | int & | x,
|  | int & | y,
|  | ModifierType& | mask
| ) |  | const

Obtains the current device position and modifier state.

The position is given in coordinates relative to the upper left corner of window.

Since gtkmm 3.0:

Parameters:

  device | Pointer Gdk::Device to query to.
  x | Return location for the X coordinate of device, or `0`.
  y | Return location for the Y coordinate of device, or `0`.
  mask | Return location for the modifier mask, or `0`.

Returns:
  The window underneath device (as with Gdk::Device::get_window_at_position()), or `0` if the window is not known to GDK.

Glib::RefPtr<Display> Gdk::Window::get_display | ( |  | ) |

Gets the Gdk::Display associated with a Gdk::Window.

Since gtkmm 2.24:

Returns:
  The Gdk::Display associated with window.

Glib::RefPtr<const Display> Gdk::Window::get_display | ( |  | ) | const

Gets the Gdk::Display associated with a Gdk::Window.

Since gtkmm 2.24:

Returns:
  The Gdk::Display associated with window.

DragProtocol Gdk::Window::get_drag_protocol | ( | Glib::RefPtr< Window >& | target | ) | const

Finds out the DND protocol supported by a window.

Since gtkmm 3.0:

Parameters:

  target | Location of the window where the drop should happen. This may be window or a proxy window, or `0` if window does not support Drag and Drop.

Returns:
  The supported DND protocol.

DragProtocol Gdk::Window::get_drag_protocol | ( |  | ) | const

Glib::RefPtr<Window> Gdk::Window::get_effective_parent | ( |  | ) |

Obtains the parent of window, as known to GDK.

Works like get_parent() for normal windows, but returns the window's embedder for offscreen windows.

See also: gdk_offscreen_window_get_embedder()

Since gtkmm 2.22:

Returns:
  Effective parent of window.

Glib::RefPtr<const Window> Gdk::Window::get_effective_parent | ( |  | ) | const

Obtains the parent of window, as known to GDK.

Works like get_parent() for normal windows, but returns the window's embedder for offscreen windows.

See also: gdk_offscreen_window_get_embedder()

Since gtkmm 2.22:

Returns:
  Effective parent of window.

Glib::RefPtr<Window> Gdk::Window::get_effective_toplevel | ( |  | ) |

Gets the toplevel window that's an ancestor of window.

Works like get_toplevel(), but treats an offscreen window's embedder as its parent, using get_effective_parent().

See also: gdk_offscreen_window_get_embedder()

Since gtkmm 2.22:

Returns:
  The effective toplevel window containing window.

Glib::RefPtr<const Window> Gdk::Window::get_effective_toplevel | ( |  | ) | const

Gets the toplevel window that's an ancestor of window.

Works like get_toplevel(), but treats an offscreen window's embedder as its parent, using get_effective_parent().

See also: gdk_offscreen_window_get_embedder()

Since gtkmm 2.22:

Returns:
  The effective toplevel window containing window.

EventMask Gdk::Window::get_events | ( |  | ) | const

Gets the event mask for window for all master input devices.

See set_events().

Returns:
  Event mask for window.

bool Gdk::Window::get_focus_on_map | ( |  | ) | const

Determines whether or not the desktop environment should be hinted that the window does not want to receive input focus when it is mapped.

Since gtkmm 2.22:

Returns:
  Whether or not the window wants to receive input focus when it is mapped.

void Gdk::Window::get_frame_extents | ( | Rectangle& | rect | ) |

Obtains the bounding box of the window, including window manager titlebar/borders if any.

The frame position is given in root window coordinates. To get the position of the window itself (rather than the frame) in root window coordinates, use get_origin().

Parameters:

  rect | Rectangle to fill with bounding box of the window frame.

void Gdk::Window::get_geometry | ( | int & | x,
|  | int & | y,
|  | int & | width,
|  | int & | height
| ) |  | const

Any of the return location arguments to this function may be `0`, if you aren't interested in getting the value of that field.

The X and Y coordinates returned are relative to the parent window of window, which for toplevels usually means relative to the window decorations (titlebar, etc.) rather than relative to the root window (screen-size background window).

On the X11 platform, the geometry is obtained from the X server, so reflects the latest position of window; this may be out-of-sync with the position of window delivered in the most-recently-processed Gdk::EventConfigure. get_position() in contrast gets the position from the most recent configure event.

<note> If window is not a toplevel, it is much better to call get_position(), get_width() and get_height() instead, because it avoids the roundtrip to the X server and because these functions support the full 32-bit coordinate space, whereas get_geometry() is restricted to the 16-bit coordinates of X11. </note>

Parameters:

  x | Return location for X coordinate of window (relative to its parent).
  y | Return location for Y coordinate of window (relative to its parent).
  width | Return location for width of window.
  height | Return location for height of window.

Glib::RefPtr<Window> Gdk::Window::get_group | ( |  | ) |

Returns the group leader window for window.

See set_group().

Since gtkmm 2.4:

Returns:
  The group leader window for window.

Glib::RefPtr<const Window> Gdk::Window::get_group | ( |  | ) | const

Returns the group leader window for window.

See set_group().

Since gtkmm 2.4:

Returns:
  The group leader window for window.

int Gdk::Window::get_height | ( |  | ) | const

Returns the height of the given window.

On the X11 platform the returned size is the size reported in the most-recently-processed configure event, rather than the current size on the X server.

Since gtkmm 2.24:

Returns:
  The height of window.

bool Gdk::Window::get_modal_hint | ( |  | ) | const

Determines whether or not the window manager is hinted that window has modal behaviour.

Since gtkmm 2.22:

Returns:
  Whether or not the window has the modal hint set.

Glib::RefPtr<Window> Gdk::Window::get_offscreen_embedder | ( |  | ) |

Gets the window that window is embedded in.

Since gtkmm 2.18:

Parameters:

  window | A Gdk::Window.

Returns:
  The embedding Gdk::Window, or `0` if window is not an mbedded offscreen window.

Glib::RefPtr<const Window> Gdk::Window::get_offscreen_embedder | ( |  | ) | const

Gets the window that window is embedded in.

Since gtkmm 2.18:

Parameters:

  window | A Gdk::Window.

Returns:
  The embedding Gdk::Window, or `0` if window is not an mbedded offscreen window.

::Cairo::RefPtr< ::Cairo::Surface> Gdk::Window::get_offscreen_surface | ( |  | ) |

Gets the offscreen surface that an offscreen window renders into.

If you need to keep this around over window resizes, you need to add a reference to it.

Parameters:

  window | A Gdk::Window.

Returns:
  The offscreen surface, or `0` if not offscreen.

::Cairo::RefPtr<const ::Cairo::Surface> Gdk::Window::get_offscreen_surface | ( |  | ) | const

Gets the offscreen surface that an offscreen window renders into.

If you need to keep this around over window resizes, you need to add a reference to it.

Parameters:

  window | A Gdk::Window.

Returns:
  The offscreen surface, or `0` if not offscreen.

int Gdk::Window::get_origin | ( | int & | x,
|  | int & | y
| ) |  | const

Obtains the position of a window in root window coordinates.

(Compare with get_position() and get_geometry() which return the position of a window relative to its parent window.)

Parameters:

  x | Return location for X coordinate.
  y | Return location for Y coordinate.

Returns:
  Not meaningful, ignore.

Glib::RefPtr<Window> Gdk::Window::get_parent | ( |  | ) |

Obtains the parent of window, as known to GDK.

Does not query the X server; thus this returns the parent as passed to new(), not the actual parent. This should never matter unless you're using Xlib calls mixed with GDK calls on the X11 platform. It may also matter for toplevel windows, because the window manager may choose to reparent them.

Note that you should use get_effective_parent() when writing generic code that walks up a window hierarchy, because get_parent() will most likely not do what you expect if there are offscreen windows in the hierarchy.

Returns:
  Parent of window.

Glib::RefPtr<const Window> Gdk::Window::get_parent | ( |  | ) | const

Obtains the parent of window, as known to GDK.

Does not query the X server; thus this returns the parent as passed to new(), not the actual parent. This should never matter unless you're using Xlib calls mixed with GDK calls on the X11 platform. It may also matter for toplevel windows, because the window manager may choose to reparent them.

Note that you should use get_effective_parent() when writing generic code that walks up a window hierarchy, because get_parent() will most likely not do what you expect if there are offscreen windows in the hierarchy.

Returns:
  Parent of window.

Glib::RefPtr<Window> Gdk::Window::get_pointer | ( | int & | x,
|  | int & | y,
|  | ModifierType& | mask
| ) |  |

Obtains the current pointer position and modifier state.

The position is given in coordinates relative to the upper left corner of window.

Deprecated: 3.0: Use get_device_position() instead.

Deprecated:
  Use get_device_position() instead

Parameters:

  x | Return location for X coordinate of pointer or `0` to not return the X coordinate.
  y | Return location for Y coordinate of pointer or `0` to not return the Y coordinate.
  mask | Return location for modifier mask or `0` to not return the modifier mask.

Returns:
  The window containing the pointer (as with at_pointer()), or `0` if the window containing the pointer isn't known to GDK.

void Gdk::Window::get_position | ( | int & | x,
|  | int & | y
| ) |  | const

Obtains the position of the window as reported in the most-recently-processed Gdk::EventConfigure.

Contrast with get_geometry() which queries the X server for the current window position, regardless of which events have been received or processed.

The position coordinates are relative to the window's parent window.

Parameters:

  x | X coordinate of window.
  y | Y coordinate of window.

void Gdk::Window::get_root_coords | ( | int | x,
|  | int | y,
|  | int & | root_x,
|  | int & | root_y
| ) |  |

Obtains the position of a window position in root window coordinates.

This is similar to get_origin() but allows you go pass in any position in the window, not just the origin.

Since gtkmm 2.18:

Parameters:

  x | X coordinate in window.
  y | Y coordinate in window.
  root_x | Return location for X coordinate.
  root_y | Return location for Y coordinate.

void Gdk::Window::get_root_origin | ( | int & | x,
|  | int & | y
| ) |  | const

Obtains the top-left corner of the window manager frame in root window coordinates.

Parameters:

  x | Return location for X position of window frame.
  y | Return location for Y position of window frame.

Glib::RefPtr<Screen> Gdk::Window::get_screen | ( |  | ) |

Gets the Gdk::Screen associated with a Gdk::Window.

Since gtkmm 2.24:

Returns:
  The Gdk::Screen associated with window.

Glib::RefPtr<const Screen> Gdk::Window::get_screen | ( |  | ) | const

Gets the Gdk::Screen associated with a Gdk::Window.

Since gtkmm 2.24:

Returns:
  The Gdk::Screen associated with window.

EventMask Gdk::Window::get_source_events | ( | InputSource | source | ) | const

Returns the event mask for window corresponding to the device class specified by source.

Parameters:

  source | A Gdk::InputSource to define the source class.

Returns:
  Source event mask for window.

WindowState Gdk::Window::get_state | ( |  | ) | const

Gets the bitwise OR of the currently active window state flags, from the Gdk::WindowState enumeration.

Returns:
  Window state bitfield.

bool Gdk::Window::get_support_multidevice | ( |  | ) |

Returns `true` if the window is aware of the existence of multiple devices.

Since gtkmm 3.0:

Returns:
  `true` if the window handles multidevice features.

Glib::RefPtr<Window> Gdk::Window::get_toplevel | ( |  | ) |

Gets the toplevel window that's an ancestor of window.

Any window type but Gdk::WINDOW_CHILD is considered a toplevel window, as is a Gdk::WINDOW_CHILD window that has a root window as parent.

Note that you should use get_effective_toplevel() when you want to get to a window's toplevel as seen on screen, because get_toplevel() will most likely not do what you expect if there are offscreen windows in the hierarchy.

Returns:
  The toplevel window containing window.

Glib::RefPtr<const Window> Gdk::Window::get_toplevel | ( |  | ) | const

Gets the toplevel window that's an ancestor of window.

Any window type but Gdk::WINDOW_CHILD is considered a toplevel window, as is a Gdk::WINDOW_CHILD window that has a root window as parent.

Note that you should use get_effective_toplevel() when you want to get to a window's toplevel as seen on screen, because get_toplevel() will most likely not do what you expect if there are offscreen windows in the hierarchy.

Returns:
  The toplevel window containing window.

WindowTypeHint Gdk::Window::get_type_hint | ( |  | ) |

This function returns the type hint set for a window.

Since gtkmm 2.10:

Returns:
  The type hint set for window.

::Cairo::RefPtr< ::Cairo::Region> Gdk::Window::get_update_area | ( |  | ) |

Transfers ownership of the update area from window to the caller of the function.

That is, after calling this function, window will no longer have an invalid/dirty region; the update area is removed from window and handed to you. If a window has no update area, get_update_area() returns an invalid Region.

Returns:
  The update area for window.

void Gdk::Window::get_user_data | ( | gpointer * | data | ) |

Retrieves the user data for window, which is normally the widget that window belongs to.

See set_user_data().

Parameters:

  data | Return location for user data.

::Cairo::RefPtr< ::Cairo::Region> Gdk::Window::get_visible_region | ( |  | ) | const

Computes the region of the window that is potentially visible.

This does not necessarily take into account if the window is obscured by other windows, but no area outside of this region is visible.

Returns:
  A #cairo_region_t. This must be freed with cairo_region_destroy() when you are done.

Glib::RefPtr<Visual> Gdk::Window::get_visual | ( |  | ) |

Gets the Gdk::Visual describing the pixel format of window.

Since gtkmm 2.24:

Returns:
  A Gdk::Visual.

Glib::RefPtr<const Visual> Gdk::Window::get_visual | ( |  | ) | const

Gets the Gdk::Visual describing the pixel format of window.

Since gtkmm 2.24:

Returns:
  A Gdk::Visual.

int Gdk::Window::get_width | ( |  | ) | const

Returns the width of the given window.

On the X11 platform the returned size is the size reported in the most-recently-processed configure event, rather than the current size on the X server.

Since gtkmm 2.24:

Returns:
  The width of window.

WindowType Gdk::Window::get_window_type | ( |  | ) | const

Gets the type of the window.

See Gdk::WindowType.

Returns:
  Type of window.

GdkWindow* Gdk::Window::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GdkWindow* Gdk::Window::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GdkWindow* Gdk::Window::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gdk::Window::has_native | ( |  | ) | const

Checks whether the window has a native window or not.

Note that you can use ensure_native() if a native window is needed.

Since gtkmm 2.22:

Returns:
  `true` if the window has a native window, `false` otherwise.

void Gdk::Window::hide | ( |  | ) |

For toplevel windows, withdraws them, so they will no longer be known to the window manager; for all windows, unmaps them, so they won't be displayed.

Normally done automatically as part of gtk_widget_hide().

void Gdk::Window::iconify | ( |  | ) |

Asks to iconify (minimize) window.

The window manager may choose to ignore the request, but normally will honor it. Using gtk_window_iconify() is preferred, if you have a Gtk::Window widget.

This function only makes sense when window is a toplevel window.

void Gdk::Window::input_shape_combine_region | ( | const ::Cairo::RefPtr< ::Cairo::Region > & | shape_region,
|  | int | offset_x,
|  | int | offset_y
| ) |  |

Like shape_combine_region(), but the shape applies only to event handling.

Mouse events which happen while the pointer position corresponds to an unset bit in the mask will be passed on the window below window.

An input shape is typically used with RGBA windows. The alpha channel of the window defines which pixels are invisible and allows for nicely antialiased borders, and the input shape controls where the window is "clickable".

On the X11 platform, this requires version 1.1 of the shape extension.

On the Win32 platform, this functionality is not present and the function does nothing.

Since gtkmm 2.10:

Parameters:

  shape_region | Region of window to be non-transparent.
  offset_x | X position of shape_region in window coordinates.
  offset_y | Y position of shape_region in window coordinates.

void Gdk::Window::invalidate | ( | bool | invalidate_children | ) |

A convenience wrapper around invalidate_region() which invalidates the whole region.

See invalidate_region() for details.

Parameters:

  invalidate_children | Whether to also invalidate child windows.

void Gdk::Window::invalidate_rect | ( | const Rectangle& | rect,
|  | bool | invalidate_children
| ) |  |

A convenience wrapper around invalidate_region() which invalidates a rectangular region.

See invalidate_region() for details. See also the invalidate_rect() method overload with no rect parameter, to invalidate the whole region.

Parameters:

  rect | Rectangle to invalidate.
  invalidate_children | Whether to also invalidate child windows.

void Gdk::Window::invalidate_region | ( | const ::Cairo::RefPtr< ::Cairo::Region > & | region,
|  | bool | invalidate_children = `true`
| ) |  |

Adds region to the update area for window.

The update area is the region that needs to be redrawn, or "dirty region." The call process_updates() sends one or more expose events to the window, which together cover the entire update area. An application would normally redraw the contents of window in response to those expose events.

GDK will call process_all_updates() on your behalf whenever your program returns to the main loop and becomes idle, so normally there's no need to do that manually, you just need to invalidate regions that you know should be redrawn.

The invalidate_children parameter controls whether the region of each child window that intersects region will also be invalidated. If `false`, then the update area for child windows will remain unaffected. See gdk_window_invalidate_maybe_recurse if you need fine grained control over which children are invalidated.

Parameters:

  region | A #cairo_region_t.
  invalidate_children | `true` to also invalidate child windows.

bool Gdk::Window::is_input_only | ( |  | ) | const

Determines whether or not the window is an input only window.

Since gtkmm 2.22:

Returns:
  `true` if window is input only.

bool Gdk::Window::is_shaped | ( |  | ) | const

Determines whether or not the window is shaped.

Since gtkmm 2.22:

Returns:
  `true` if window is shaped.

bool Gdk::Window::is_viewable | ( |  | ) | const

Check if the window and all ancestors of the window are mapped.

(This is not necessarily "viewable" in the X sense, since we only check as far as we have GDK window parents, not to the root window.)

Returns:
  `true` if the window is viewable.

bool Gdk::Window::is_visible | ( |  | ) | const

Checks whether the window has been mapped (with show() or show_unraised()).

Returns:
  `true` if the window is mapped.

void Gdk::Window::lower | ( |  | ) |

Lowers window to the bottom of the Z-order (stacking order), so that other windows with the same parent window appear above window.

This is true whether or not the other windows are visible.

If window is a toplevel, the window manager may choose to deny the request to move the window in the Z-order, lower() only requests the restack, does not guarantee it.

Note that show() raises the window again, so don't call this function before show(). (Try show_unraised().)

void Gdk::Window::maximize | ( |  | ) |

Maximizes the window.

If the window was already maximized, then this function does nothing.

On X11, asks the window manager to maximize window, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "maximized"; so you can't rely on the maximization actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

On Windows, reliably maximizes the window.

void Gdk::Window::merge_child_input_shapes | ( |  | ) |

Merges the input shape masks for any child windows into the input shape mask for window.

i.e. the union of all input masks for window and its children will become the new input mask for window. See input_shape_combine_region().

This function is distinct from set_child_input_shapes() because it includes window's input shape mask in the set of shapes to be merged.

Since gtkmm 2.10:

void Gdk::Window::merge_child_shapes | ( |  | ) |

Merges the shape masks for any child windows into the shape mask for window.

i.e. the union of all masks for window and its children will become the new mask for window. See shape_combine_region().

This function is distinct from set_child_shapes() because it includes window's shape mask in the set of shapes to be merged.

void Gdk::Window::move | ( | int | x,
|  | int | y
| ) |  |

Repositions a window relative to its parent window.

For toplevel windows, window managers may ignore or modify the move; you should probably use gtk_window_move() on a Gtk::Window widget anyway, instead of using GDK functions. For child windows, the move will reliably succeed.

If you're also planning to resize the window, use move_resize() to both move and resize simultaneously, for a nicer visual effect.

Parameters:

  x | X coordinate relative to window's parent.
  y | Y coordinate relative to window's parent.

void Gdk::Window::move_region | ( | const ::Cairo::RefPtr< ::Cairo::Region > & | region,
|  | int | dx,
|  | int | dy
| ) |  |

Move the part of window indicated by region by dy pixels in the Y direction and dx pixels in the X direction.

The portions of region that not covered by the new position of region are invalidated.

Child windows are not moved.

Since gtkmm 2.8:

Parameters:

  region | The #cairo_region_t to move.
  dx | Amount to move in the X direction.
  dy | Amount to move in the Y direction.

void Gdk::Window::move_resize | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

Equivalent to calling move() and resize(), except that both operations are performed at once, avoiding strange visual effects.

(i.e. the user may be able to see the window first move, then resize, if you don't use move_resize().)

Parameters:

  x | New X position relative to window's parent.
  y | New Y position relative to window's parent.
  width | New width.
  height | New height.

static void Gdk::Window::process_all_updates | ( |  | ) | `[static]`

Calls process_updates() for all windows (see Gdk::Window) in the application.

void Gdk::Window::process_updates | ( | bool | update_children | ) |

Sends one or more expose events to window.

The areas in each expose event will cover the entire update area for the window (see invalidate_region() for details). Normally GDK calls process_all_updates() on your behalf, so there's no need to call this function unless you want to force expose events to be delivered immediately and synchronously (vs. the usual case, where GDK delivers them in an idle handler). Occasionally this is useful to produce nicer scrolling behavior, for example.

Parameters:

  update_children | Whether to also process updates for child windows.

Glib::PropertyProxy< Glib::RefPtr<Cursor> > Gdk::Window::property_cursor | ( |  | ) |

Cursor.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Cursor> > Gdk::Window::property_cursor | ( |  | ) | const

Cursor.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gdk::Window::raise | ( |  | ) |

Raises window to the top of the Z-order (stacking order), so that other windows with the same parent window appear below window.

This is true whether or not the windows are visible.

If window is a toplevel, the window manager may choose to deny the request to move the window in the Z-order, raise() only requests the restack, does not guarantee it.

void Gdk::Window::register_dnd | ( |  | ) |

Registers a window as a potential drop destination.

void Gdk::Window::remove_filter | ( | GdkFilterFunc | function,
|  | gpointer | data
| ) |  |

Remove a filter previously added with add_filter().

Parameters:

  function | Previously-added filter function.
  data | User data for previously-added filter function.

void Gdk::Window::reparent | ( | const Glib::RefPtr< Window >& | new_parent,
|  | int | x,
|  | int | y
| ) |  |

Reparents window into the given new_parent.

The window being reparented will be unmapped as a side effect.

Parameters:

  new_parent | New parent to move window into.
  x | X location inside the new parent.
  y | Y location inside the new parent.

void Gdk::Window::resize | ( | int | width,
|  | int | height
| ) |  |

Resizes window; for toplevel windows, asks the window manager to resize the window.

The window manager may not allow the resize. When using GTK+, use gtk_window_resize() instead of this low-level GDK function.

Windows may not be resized below 1x1.

If you're also planning to move the window, use move_resize() to both move and resize simultaneously, for a nicer visual effect.

Parameters:

  width | New width of the window.
  height | New height of the window.

void Gdk::Window::resize_drag | ( | WindowEdge | edge,
|  | const Glib::RefPtr< Device >& | device,
|  | int | button,
|  | int | root_x,
|  | int | root_y,
|  | guint32 | timestamp
| ) |  |

Begins a window resize operation (for a toplevel window).

You might use this function to implement a "window resize grip," for example; in fact Gtk::Statusbar uses it. The function works best with window managers that support the Extended Window Manager Hints, but has a fallback implementation for other window managers.

Since gtkmm 3.4:

Parameters:

  edge | The edge or corner from which the drag is started.
  device | The device used for the operation.
  button | The button being used to drag.
  root_x | Root window X coordinate of mouse click that began the drag.
  root_y | Root window Y coordinate of mouse click that began the drag.
  timestamp | Timestamp of mouse click that began the drag (use Gdk::Event::get_time()).

void Gdk::Window::restack | ( | const Glib::RefPtr< Window >& | sibling,
|  | bool | above
| ) |  |

Changes the position of window in the Z-order (stacking order), so that it is above sibling (if above is `true`) or below sibling (if above is `false`).

If sibling is `0`, then this either raises (if above is `true`) or lowers the window.

If window is a toplevel, the window manager may choose to deny the request to move the window in the Z-order, restack() only requests the restack, does not guarantee it.

Since gtkmm 2.18:

Parameters:

  sibling | A Gdk::Window that is a sibling of window, or `0`.
  above | A boolean.

void Gdk::Window::restack | ( | bool | above | ) |

Changes the position of this window in the Z-order (stacking order).

This either raises (if above is true) or lowers the window.

If this is a toplevel, the window manager may choose to deny the request to move the window in the Z-order. restack() only requests the restack but does not guarantee it.

Parameters:

  above | Whether to raise or lower the window.

Since gtkmm 2.18:

void Gdk::Window::scroll | ( | int | dx,
|  | int | dy
| ) |  |

Scroll the contents of window, both pixels and children, by the given amount.

window itself does not move. Portions of the window that the scroll operation brings in from offscreen areas are invalidated. The invalidated region may be bigger than what would strictly be necessary.

For X11, a minimum area will be invalidated if the window has no subwindows, or if the edges of the window's parent do not extend beyond the edges of the window. In other cases, a multi-step process is used to scroll the window which may produce temporary visual artifacts and unnecessary invalidations.

Parameters:

  dx | Amount to scroll in the X direction.
  dy | Amount to scroll in the Y direction.

void Gdk::Window::set_accept_focus | ( | bool | accept_focus = `true` | ) |

Setting accept_focus to `false` hints the desktop environment that the window doesn't want to receive input focus.

On X, it is the responsibility of the window manager to interpret this hint. ICCCM-compliant window manager usually respect it.

Since gtkmm 2.4:

Parameters:

  accept_focus | `true` if the window should receive input focus.

void Gdk::Window::set_background | ( | const Color& | color | ) |

Sets the background color of window.

(However, when using GTK+, set the background of a widget with gtk_widget_modify_bg() - if you're an application - or gtk_style_set_background() - if you're implementing a custom widget.)

See also set_background_pattern().

Deprecated: 3.4: Use set_background_rgba() instead.

Deprecated:
  Use the set_background() method that takes a Gdk::RGBA instead.

Parameters:

  color | A Gdk::Color.

void Gdk::Window::set_background | ( | const RGBA& | color | ) |

Sets the background color of window.

See also set_background_pattern().

Parameters:

  rgba | A Gdk::RGBA color.

void Gdk::Window::set_background | ( | const ::Cairo::RefPtr< ::Cairo::Pattern > & | pattern | ) |

Sets the background of window.

A background of `0` means that the window will inherit its background form its parent window.

The windowing system will normally fill a window with its background when the window is obscured then exposed.

Parameters:

  pattern | A pattern to use, or `0`.

void Gdk::Window::set_child_input_shapes | ( |  | ) |

Sets the input shape mask of window to the union of input shape masks for all children of window, ignoring the input shape mask of window itself.

Contrast with merge_child_input_shapes() which includes the input shape mask of window in the masks to be merged.

Since gtkmm 2.10:

void Gdk::Window::set_child_shapes | ( |  | ) |

Sets the shape mask of window to the union of shape masks for all children of window, ignoring the shape mask of window itself.

Contrast with merge_child_shapes() which includes the shape mask of window in the masks to be merged.

void Gdk::Window::set_composited | ( | bool | composited = `TRUE` | ) |

Sets a Gdk::Window as composited, or unsets it.

Composited windows do not automatically have their contents drawn to the screen. Drawing is redirected to an offscreen buffer and an expose event is emitted on the parent of the composited window. It is the responsibility of the parent's expose handler to manually merge the off-screen content onto the screen in whatever way it sees fit. See <xref linkend="composited-window-example"> for an example.

It only makes sense for child windows to be composited; see set_opacity() if you need translucent toplevel windows.

An additional effect of this call is that the area of this window is no longer clipped from regions marked for invalidation on its parent. Draws done on the parent window are also no longer clipped by the child.

This call is only supported on some systems (currently, only X11 with new enough Xcomposite and Xdamage extensions). You must call Gdk::Display::supports_composite() to check if setting a window as composited is supported before attempting to do so.

Since gtkmm 2.12:

Parameters:

  composited | `true` to set the window as composited.

void Gdk::Window::set_cursor | ( | const Glib::RefPtr< Cursor >& | cursor | ) |

Sets the mouse pointer for a Gdk::Window.

To make the cursor invisible, use gdk_cursor_new_from_pixmap() to create a cursor with no pixels in it.

Parameters:

  cursor | A cursor.

void Gdk::Window::set_cursor | ( |  | ) |

Use the parent window's cursor.

For top-level windows this means that it will use the default cursor for the ROOT window.

static void Gdk::Window::set_debug_updates | ( | bool | setting = `true` | ) | `[static]`

With update debugging enabled, calls to invalidate_region() clear the invalidated region of the screen to a noticeable color, and GDK pauses for a short time before sending exposes to windows during process_updates().

The net effect is that you can see the invalid region for each window and watch redraws as they occur. This allows you to diagnose inefficiencies in your application.

In essence, because the GDK rendering model prevents all flicker, if you are redrawing the same region 400 times you may never notice, aside from noticing a speed problem. Enabling update debugging causes GTK to flicker slowly and noticeably, so you can see exactly what's being redrawn when, in what order.

The --gtk-debug=updates command line option passed to GTK+ programs enables this debug option at application startup time. That's usually more useful than calling set_debug_updates() yourself, though you might want to use this function to enable updates sometime after application startup time.

Parameters:

  setting | `true` to turn on update debugging.

void Gdk::Window::set_decorations | ( | WMDecoration | decorations | ) |

"Decorations" are the features the window manager adds to a toplevel Gdk::Window.

This function sets the traditional Motif window manager hints that tell the window manager which decorations you would like your window to have. Usually you should use gtk_window_set_decorated() on a Gtk::Window instead of using the GDK function directly.

The decorations argument is the logical OR of the fields in the Gdk::WMDecoration enumeration. If Gdk::DECOR_ALL is included in the mask, the other bits indicate which decorations should be turned off. If Gdk::DECOR_ALL is not included, then the other bits indicate which decorations should be turned on.

Most window managers honor a decorations hint of 0 to disable all decorations, but very few honor all possible combinations of bits.

Parameters:

  decorations | Decoration hint mask.

void Gdk::Window::set_device_cursor | ( | const Glib::RefPtr< Device >& | device,
|  | const Glib::RefPtr< Cursor >& | cursor
| ) |  |

Sets a specific Gdk::Cursor for a given device when it gets inside window.

Use Gdk::Cursor::new_for_display() or Gdk::Cursor::new_from_pixbuf() to create the cursor. To make the cursor invisible, use Gdk::BLANK_CURSOR. Passing `0` for the cursor argument to set_cursor() means that window will use the cursor of its parent window. Most windows should use this default.

Since gtkmm 3.0:

Parameters:

  device | A master, pointer Gdk::Device.
  cursor | A Gdk::Cursor.

void Gdk::Window::set_device_cursor | ( | const Glib::RefPtr< Device >& | device | ) |

Use the parent window's cursor.

For top-level windows this means that it will use the default cursor for the ROOT window.

void Gdk::Window::set_device_events | ( | const Glib::RefPtr< Device >& | device,
|  | EventMask | event_mask
| ) |  |

Sets the event mask for a given device (Normally a floating device, not attached to any visible pointer) to window.

For example, an event mask including Gdk::BUTTON_PRESS_MASK means the window should report button press events. The event mask is the bitwise OR of values from the Gdk::EventMask enumeration.

Since gtkmm 3.0:

Parameters:

  device | Gdk::Device to enable events for.
  event_mask | Event mask for window.

void Gdk::Window::set_events | ( | EventMask | event_mask | ) |

The event mask for a window determines which events will be reported for that window from all master input devices.

For example, an event mask including Gdk::BUTTON_PRESS_MASK means the window should report button press events. The event mask is the bitwise OR of values from the Gdk::EventMask enumeration.

Parameters:

  event_mask | Event mask for window.

void Gdk::Window::set_focus_on_map | ( | bool | focus_on_map | ) |

Setting focus_on_map to `false` hints the desktop environment that the window doesn't want to receive input focus when it is mapped.

focus_on_map should be turned off for windows that aren't triggered interactively (such as popups from network activity).

On X, it is the responsibility of the window manager to interpret this hint. Window managers following the freedesktop.org window manager extension specification should respect it.

Since gtkmm 2.6:

Parameters:

  focus_on_map | `true` if the window should receive input focus when mapped.

void Gdk::Window::set_functions | ( | WMFunction | functions | ) |

Sets hints about the window management functions to make available via buttons on the window frame.

On the X backend, this function sets the traditional Motif window manager hint for this purpose. However, few window managers do anything reliable or interesting with this hint. Many ignore it entirely.

The functions argument is the logical OR of values from the Gdk::WMFunction enumeration. If the bitmask includes Gdk::FUNC_ALL, then the other bits indicate which functions to disable; if it doesn't include Gdk::FUNC_ALL, it indicates which functions to enable.

Parameters:

  functions | Bitmask of operations to allow on window.

void Gdk::Window::set_geometry_hints | ( | const Geometry& | geometry,
|  | WindowHints | geom_mask
| ) |  |

Sets the geometry hints for window.

Hints flagged in geom_mask are set, hints not flagged in geom_mask are unset. To unset all hints, use a geom_mask of 0 and a geometry of `0`.

This function provides hints to the windowing system about acceptable sizes for a toplevel window. The purpose of this is to constrain user resizing, but the windowing system will typically (but is not required to) also constrain the current size of the window to the provided values and constrain programatic resizing via resize() or move_resize().

Note that on X11, this effect has no effect on windows of type Gdk::WINDOW_TEMP or windows where override redirect has been turned on via set_override_redirect() since these windows are not resizable by the user.

Since you can't count on the windowing system doing the constraints for programmatic resizes, you should generally call constrain_size() yourself to determine appropriate sizes.

Parameters:

  geometry | Geometry hints.
  geom_mask | Bitmask indicating fields of geometry to pay attention to.

void Gdk::Window::set_group | ( | const Glib::RefPtr< Window >& | leader | ) |

Sets the group leader window for window.

By default, GDK sets the group leader for all toplevel windows to a global window implicitly created by GDK. With this function you can override this default.

The group leader window allows the window manager to distinguish all windows that belong to a single application. It may for example allow users to minimize/unminimize all windows belonging to an application at once. You should only set a non-default group window if your application pretends to be multiple applications.

Parameters:

  leader | Group leader window, or `0` to restore the default group leader window.

void Gdk::Window::set_icon_list | ( | const std::vector< Glib::RefPtr< Gdk::Pixbuf > >& | pixbufs | ) |

Sets a list of icons for the window.

One of these will be used to represent the window when it has been iconified. The icon is usually shown in an icon box or some sort of task bar. Which icon size is shown depends on the window manager. The window manager can scale the icon but setting several size icons can give better image quality since the window manager may only need to scale the icon by a small amount or not at all.

Parameters:

  pixbufs | A list of pixbufs, of different sizes.

void Gdk::Window::set_icon_name | ( | const Glib::ustring & | name | ) |

Windows may have a name used while minimized, distinct from the name they display in their titlebar.

Most of the time this is a bad idea from a user interface standpoint. But you can set such a name with this function, if you like.

After calling this with a non-`0` name, calls to set_title() will not update the icon title.

Using `0` for name unsets the icon title; further calls to set_title() will again update the icon title as well.

Parameters:

  name | Name of window while iconified (minimized).

void Gdk::Window::set_keep_above | ( | bool | setting = `true` | ) |

Set if window must be kept above other windows.

If the window was already above, then this function does nothing.

On X11, asks the window manager to keep window above, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "keep above"; so you can't rely on the window being kept above. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

Since gtkmm 2.4:

Parameters:

  setting | Whether to keep window above other windows.

void Gdk::Window::set_keep_below | ( | bool | setting = `true` | ) |

Set if window must be kept below other windows.

If the window was already below, then this function does nothing.

On X11, asks the window manager to keep window below, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "keep below"; so you can't rely on the window being kept below. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

Since gtkmm 2.4:

Parameters:

  setting | Whether to keep window below other windows.

void Gdk::Window::set_modal_hint | ( | bool | modal = `true` | ) |

The application can use this hint to tell the window manager that a certain window has modal behaviour.

The window manager can use this information to handle modal windows in a special way.

You should only use this on windows for which you have previously called set_transient_for()

Parameters:

  modal | `true` if the window is modal, `false` otherwise.

void Gdk::Window::set_offscreen_embedder | ( | const Glib::RefPtr< Window >& | embedder | ) |

Sets window to be embedded in embedder.

To fully embed an offscreen window, in addition to calling this function, it is also necessary to handle the Gdk::Window::signal_pick_embedded_child() signal on the embedder and the Gdk::Window::signal_to_embedder() and Gdk::Window::signal_from_embedder() signals on window.

Since gtkmm 2.18:

Parameters:

  window | A Gdk::Window.
  embedder | The Gdk::Window that window gets embedded in.

void Gdk::Window::set_opacity | ( | double | opacity | ) |

Request the windowing system to make window partially transparent, with opacity 0 being fully transparent and 1 fully opaque.

(Values of the opacity parameter are clamped to the [0,1] range.)

On X11, this works only on X screens with a compositing manager running.

For setting up per-pixel alpha, see Gdk::Screen::get_rgba_visual(). For making non-toplevel windows translucent, see set_composited().

Since gtkmm 2.12:

Parameters:

  opacity | Opacity.

void Gdk::Window::set_override_redirect | ( | bool | override_redirect = `true` | ) |

An override redirect window is not under the control of the window manager.

This means it won't have a titlebar, won't be minimizable, etc. - it will be entirely under the control of the application. The window manager can't see the override redirect window at all.

Override redirect should only be used for short-lived temporary windows, such as popup menus. Gtk::Menu uses an override redirect window in its implementation, for example.

Parameters:

  override_redirect | `true` if window should be override redirect.

void Gdk::Window::set_role | ( | const Glib::ustring & | role | ) |

When using GTK+, typically you should use gtk_window_set_role() instead of this low-level function.

The window manager and session manager use a window's role to distinguish it from other kinds of window in the same application. When an application is restarted after being saved in a previous session, all windows with the same title and role are treated as interchangeable. So if you have two windows with the same title that should be distinguished for session management purposes, you should set the role on those windows. It doesn't matter what string you use for the role, as long as you have a different role for each non-interchangeable kind of window.

Parameters:

  role | A string indicating its role.

void Gdk::Window::set_skip_pager_hint | ( | bool | skips_pager = `true` | ) |

Toggles whether a window should appear in a pager (workspace switcher, or other desktop utility program that displays a small thumbnail representation of the windows on the desktop).

If a window's semantic type as specified with set_type_hint() already fully describes the window, this function should not be called in addition, instead you should allow the window to be treated according to standard policy for its semantic type.

Since gtkmm 2.2:

Parameters:

  skips_pager | `true` to skip the pager.

void Gdk::Window::set_skip_taskbar_hint | ( | bool | skips_taskbar = `true` | ) |

Toggles whether a window should appear in a task list or window list.

If a window's semantic type as specified with set_type_hint() already fully describes the window, this function should not be called in addition, instead you should allow the window to be treated according to standard policy for its semantic type.

Since gtkmm 2.2:

Parameters:

  skips_taskbar | `true` to skip the taskbar.

void Gdk::Window::set_source_events | ( | InputSource | source,
|  | EventMask | event_mask
| ) |  |

Sets the event mask for any floating device (i.e. not attached to any visible pointer) that has the source defined as source.

This event mask will be applied both to currently existing, newly added devices after this call, and devices being attached/detached.

Since gtkmm 3.0:

Parameters:

  source | A Gdk::InputSource to define the source class.
  event_mask | Event mask for window.

void Gdk::Window::set_startup_id | ( | const Glib::ustring & | startup_id | ) |

When using GTK+, typically you should use gtk_window_set_startup_id() instead of this low-level function.

Since gtkmm 2.12:

Parameters:

  startup_id | A string with startup-notification identifier.

bool Gdk::Window::set_static_gravities | ( | bool | use_static = `true` | ) |

Set the bit gravity of the given window to static, and flag it so all children get static subwindow gravity.

This is used if you are implementing scary features that involve deep knowledge of the windowing system. Don't worry about it unless you have to.

Parameters:

  use_static | `true` to turn on static gravity.

Returns:
  `true` if the server supports static gravity.

void Gdk::Window::set_support_multidevice | ( | bool | support_multidevice = `true` | ) |

This function will enable multidevice features in window.

Multidevice aware windows will need to handle properly multiple, per device enter/leave events, device grabs and grab ownerships.

Since gtkmm 3.0:

Parameters:

  support_multidevice | `true` to enable multidevice support in window.

void Gdk::Window::set_title | ( | const Glib::ustring & | title | ) |

Sets the title of a toplevel window, to be displayed in the titlebar.

If you haven't explicitly set the icon name for the window (using set_icon_name()), the icon name will be set to title as well. title must be in UTF-8 encoding (as with all user-readable strings in GDK/GTK+). title may not be `0`.

Parameters:

  title | Title of window.

void Gdk::Window::set_transient_for | ( | const Glib::RefPtr< Window >& | parent | ) |

Indicates to the window manager that window is a transient dialog associated with the application window parent.

This allows the window manager to do things like center window on parent and keep window above parent.

See gtk_window_set_transient_for() if you're using Gtk::Window or Gtk::Dialog.

Parameters:

  parent | Another toplevel Gdk::Window.

void Gdk::Window::set_type_hint | ( | WindowTypeHint | hint | ) |

The application can use this call to provide a hint to the window manager about the functionality of a window.

The window manager can use this information when determining the decoration and behaviour of the window.

The hint must be set before the window is mapped.

Parameters:

  hint | A hint of the function this window will have.

void Gdk::Window::set_urgency_hint | ( | bool | urgent = `true` | ) |

Toggles whether a window needs the user's urgent attention.

Since gtkmm 2.8:

Parameters:

  urgent | `true` if the window is urgent.

void Gdk::Window::set_user_data | ( | gpointer | user_data | ) |

For most purposes this function is deprecated in favor of Glib::object_set_data().

However, for historical reasons GTK+ stores the Gtk::Widget that owns a Gdk::Window as user data on the Gdk::Window. So, custom widget implementations should use this function for that. If GTK+ receives an event for a Gdk::Window, and the user data for the window is non-`0`, GTK+ will assume the user data is a Gtk::Widget, and forward the event to that widget.

Parameters:

  user_data | User data.

void Gdk::Window::shape_combine_region | ( | const ::Cairo::RefPtr< ::Cairo::Region > & | shape_region,
|  | int | offset_x = `0`,
|  | int | offset_y = `0`
| ) |  |

Makes pixels in window outside shape_region be transparent, so that the window may be nonrectangular.

If shape_region is `0`, the shape will be unset, so the whole window will be opaque again. offset_x and offset_y are ignored if shape_region is `0`.

On the X11 platform, this uses an X server extension which is widely available on most common platforms, but not available on very old X servers, and occasionally the implementation will be buggy. On servers without the shape extension, this function will do nothing.

This function works on both toplevel and child windows.

Parameters:

  shape_region | Region of window to be non-transparent.
  offset_x | X position of shape_region in window coordinates.
  offset_y | Y position of shape_region in window coordinates.

void Gdk::Window::show | ( |  | ) |

Like show_unraised(), but also raises the window to the top of the window stack (moves the window to the front of the Z-order).

This function maps a window so it's visible onscreen. Its opposite is hide().

When implementing a Gtk::Widget, you should call this function on the widget's Gdk::Window as part of the "map" method.

void Gdk::Window::show_unraised | ( |  | ) |

Shows a Gdk::Window onscreen, but does not modify its stacking order.

In contrast, show() will raise the window to the top of the window stack.

On the X11 platform, in Xlib terms, this function calls XMapWindow() (it also updates some internal GDK state, which means that you can't really use XMapWindow() directly on a GDK window).

void Gdk::Window::stick | ( |  | ) |

"Pins" a window such that it's on all workspaces and does not scroll with viewports, for window managers that have scrollable viewports.

(When using Gtk::Window, gtk_window_stick() may be more useful.)

On the X11 platform, this function depends on window manager support, so may have no effect with many window managers. However, GDK will do the best it can to convince the window manager to stick the window. For window managers that don't support this operation, there's nothing you can do to force it to happen.

void Gdk::Window::thaw_updates | ( |  | ) |

Thaws a window frozen with Gdk::Window::freeze_updates().

void Gdk::Window::unfullscreen | ( |  | ) |

Moves the window out of fullscreen mode.

If the window was not fullscreen, does nothing.

On X11, asks the window manager to move window out of the fullscreen state, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "fullscreen"; so you can't rely on the unfullscreenification actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

Since gtkmm 2.2:

void Gdk::Window::unmaximize | ( |  | ) |

Unmaximizes the window.

If the window wasn't maximized, then this function does nothing.

On X11, asks the window manager to unmaximize window, if the window manager supports this operation. Not all window managers support this, and some deliberately ignore it or don't have a concept of "maximized"; so you can't rely on the unmaximization actually happening. But it will happen with most standard window managers, and GDK makes a best effort to get it to happen.

On Windows, reliably unmaximizes the window.

void Gdk::Window::unset_icon | ( |  | ) |

void Gdk::Window::unstick | ( |  | ) |

Reverse operation for stick(); see stick(), and gtk_window_unstick().

void Gdk::Window::withdraw | ( |  | ) |

Withdraws a window (unmaps it and asks the window manager to forget about it).

This function is not really useful as hide() automatically withdraws toplevel windows before hiding them.

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Window > wrap | ( | GdkWindow * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/window.h